//+------------------------------------------------------------------+
//|                                              -.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
//      
#property show_inputs
//   
extern int delay = 100;
//     
extern int Razvorot=372;
//      
extern int PryamoyHod=124;
//     
extern int Dlina=2;
//  
extern bool Setka=false;
//     
extern string BeginDate="2000.01.01 00:00";
//    
bool initOk = true;
//        
double PP;
//           
string Names[],Names1[],VLines[],HLines[];
//   
int prev[];
//  
int init() 
{
   //    
   if (!ObjectCreate("Our_Time", OBJ_VLINE, 0, WindowTimeOnDropped(), 0)) 
   {
      Print("     Our_Time");
      initOk = false;
      return (0);
   }
   //    
   ObjectSet("Our_Time", OBJPROP_COLOR, Green);
//   ObjectsDeleteAll();
   //  
   WindowRedraw();
   return (0);
}

//  
int deinit() 
{
   //     - 
   if (!initOk) 
   {
      return (0);
   }
   //   
   ObjectDelete("Our_Time");
   //  
   //ObjectsDeleteAll();
   //  
   for(int l=ArraySize(Names)-1;l>=0;l--)
     {
      ObjectDelete(Names[l]);
      ObjectDelete(Names1[l]);
     }
     if(Setka)
     {     
      for( l=ArraySize(VLines)-1;l>=0;l--)
         ObjectDelete(VLines[l]);
      for( l=ArraySize(HLines)-1;l>=0;l--)
         ObjectDelete(HLines[l]);
      }
   WindowRedraw();
   return (0);
}


int start()
  {
//----
   int nach_bar;
   int temp2;
   double Ptemp;
   int bgbr=iBarShift(NULL,0,StrToTime(BeginDate));
   double BegPrice=Open[bgbr];
   bool krestik;
   string name,name1,nameHLine,nameVLine;
   int ch,chvl,chhl;
   double min_znach,max_znach;
   //     - 
   if (!initOk) 
   {
      return (0);
   }
   //    
   datetime timePrevLine = -1;
   while (!IsStopped()) 
   {
      //       
      Sleep(delay);
      //       (  - )
      if (ObjectFind("Our_Time") == -1) 
      {
         Print("   Our_Time");
         break;
      }
      //    
      datetime timeLine = ObjectGet("Our_Time", OBJPROP_TIME1);
      //    
      if (timeLine == timePrevLine)
      {
         continue;
      }
      
      //  
      for(int l=ch-1;l>=0;l--)
         {
         ObjectDelete(Names[l]);
         ObjectDelete(Names1[l]);
         }
      ch=0;    
      if(Setka)
      {
      for( l=chvl-1;l>=0;l--)
         ObjectDelete(VLines[l]);
      chvl=0;
      for( l=chhl-1;l>=0;l--)
         ObjectDelete(HLines[l]);
      chhl=0;
      }
      timePrevLine = timeLine;
      //   
      int shiftLine = iBarShift(Symbol(), Period(), timeLine);
      if (shiftLine==0)
      {
         Alert("   ");
         break;
      }
      //  
      PP=z(prev,Razvorot,PryamoyHod,bgbr,shiftLine,BegPrice,0);
      //   
      if((bgbr-shiftLine)/Dlina<ArraySize(prev))
      {
         Alert(" :    = "+ArraySize(prev)+"     = "+(Bars-1-shiftLine));
         break;
      }
      //  ***********************
      // ,    
      nach_bar=shiftLine+ArraySize(prev)*Dlina;
      Ptemp=BegPrice;//    
      //          
      if(Setka)
      {
      double promejut[];
      ArrayResize(promejut,ArraySize(prev));
      ArrayInitialize(promejut,0.0);
      promejut[0]=BegPrice+prev[0]*PryamoyHod*Point;
      for(int q=1;q<=ArraySize(prev)-1;q++)
         {
         promejut[q]=promejut[q-1]+prev[q]*PryamoyHod*Point;
         }
      min_znach=promejut[ArrayMinimum(promejut)];
      max_znach=promejut[ArrayMaximum(promejut)];
      Print(min_znach+"   "+max_znach);
      //   
      for(int a=nach_bar;a>=shiftLine;a=a-Dlina)
      {
         chvl++;
         ArrayResize(VLines,chvl);
         nameVLine="VLine"+chvl;
         VLines[chvl-1]=nameVLine;
         ObjectCreate(nameVLine,OBJ_VLINE,0,Time[a],0);
         ObjectSet(nameVLine,OBJPROP_COLOR,Silver);
      }
      //   
      for(double o=min_znach;o<=max_znach;o=o+PryamoyHod*Point)
      {
         chhl++;
         ArrayResize(HLines,chhl);
         nameHLine="HLine"+chhl;
         HLines[chhl-1]=nameHLine;
         ObjectCreate(nameHLine,OBJ_HLINE,0,Time[1],o);
         ObjectSet(nameHLine,OBJPROP_COLOR,Silver);
      }
      }
         
      for(int i=0;i<=ArraySize(prev);i++)//   
      {
         //Print(prev[i]);
         if(prev[i]<0)//     
            {
            krestik=false;
            temp2=-prev[i];
            }
         else
            {
            krestik=true;
            temp2=prev[i];
            }   
            if(i!=0)//          
            {
               if(krestik)// 
               {
                  Ptemp=Ptemp+PryamoyHod*Point;
               }
               else// 
               {
                  Ptemp=Ptemp-PryamoyHod*Point;
               }
            }
         for(int j=temp2;j>0;j--)//   
         {
               name="Prev"+i+"a"+j;
               name1="Prev_"+i+"a"+j;

               if(krestik)
               {
                  
                  ch++;
                  ArrayResize(Names,ch);
                  ArrayResize(Names1,ch);
                  Names[ch-1]=name;
                  Names1[ch-1]=name1;
                  // 
                  //Print(Ptemp+"               "+(Ptemp+PryamoyHod*Point));
                  ObjectCreate(name,OBJ_RECTANGLE,0,Time[nach_bar-i*Dlina],Ptemp,Time[nach_bar-i*Dlina-Dlina],Ptemp+PryamoyHod*Point);
                  ObjectSet(name,OBJPROP_COLOR,OldLace);
                  ObjectSet(name,OBJPROP_BACK,true);
                  // 
                  ObjectCreate(name1,OBJ_RECTANGLE,0,Time[nach_bar-i*Dlina],Ptemp,Time[nach_bar-i*Dlina-Dlina],Ptemp+PryamoyHod*Point);
                  ObjectSet(name1,OBJPROP_COLOR,Black);
                  ObjectSet(name1,OBJPROP_BACK,false);

                  Ptemp=Ptemp+PryamoyHod*Point;
            
               }
               else
               {  
                  
                  ch++;
                  ArrayResize(Names,ch);
                  ArrayResize(Names1,ch);
                  Names[ch-1]=name;
                  Names1[ch-1]=name1;
                  // 
                  //Print(Ptemp+"               "+(Ptemp-PryamoyHod*Point));
                  ObjectCreate(name,OBJ_RECTANGLE,0,Time[nach_bar-i*Dlina],Ptemp,Time[nach_bar-i*Dlina-Dlina],Ptemp-PryamoyHod*Point);
                  ObjectSet(name,OBJPROP_COLOR,Red);
                  ObjectSet(name,OBJPROP_BACK,true);
                  // 
                  ObjectCreate(name1,OBJ_RECTANGLE,0,Time[nach_bar-i*Dlina],Ptemp,Time[nach_bar-i*Dlina-Dlina],Ptemp-PryamoyHod*Point);
                  ObjectSet(name1,OBJPROP_COLOR,Black);
                  ObjectSet(name1,OBJPROP_BACK,false);

                  Ptemp=Ptemp-PryamoyHod*Point;
                  
               }
         }
      }
      Comment(shiftLine);
   }   

      
      


//----
   return(0);
  }
//+------------------------------------------------------------------+

// ****************************************************************************************
//          
// k[]- 
// razv-  
// prhod-   
// begin-   
// end-   
// begin_price-    
// vektor-  -1 , +1 
//*****************************************************************************************
double z (int& k[],int razv,int prhod,int begin,int end,double begin_price,int vektor)
{
   double pr=begin_price;// 
   int index=0;//  
   int temp1;
   ArrayResize(k,1);// 
   ArrayInitialize(k,vektor); //  
   
   for(int i=begin;i>=end;i--)//    
   {
     if(k[index]>=0)//         =+,0=0  - 
     {
      if(High[i]>=pr+prhod*Point)//   
      {
         //     
         temp1=((High[i]-pr)/Point)/prhod;
         //  
         pr=pr+prhod*temp1*Point;
         // 
         k[index]=k[index]+temp1;
         continue;
      }   
      if(Low[i]<=pr-razv*Point)//   
      {
         //     
         temp1=((pr-Low[i])/Point)/prhod;
         //  
         pr=pr-prhod*temp1*Point;
         //     
         index++;
         ArrayResize(k,index+1);
         //  
         k[index]=-temp1;
      }
     }
     else
     {
      if(Low[i]<=pr-prhod*Point)//   
      {
         //     
         temp1=((pr-Low[i])/Point)/prhod;
         //  
         pr=pr-prhod*temp1*Point;
         // 
         k[index]=k[index]-temp1;
         continue;
      }   
      if(High[i]>=pr+razv*Point)//   
      {
         //     
         temp1=((High[i]-pr)/Point)/prhod;
         //  
         pr=pr+prhod*temp1*Point;
         //     
         index++;
         ArrayResize(k,index+1);
         //  
         k[index]=temp1;
      }

     } 
   }      
   return(pr);   
}